"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Service {
    constructor(definition, sender) {
        for (const key in definition) {
            const def = definition[key];
            this[key] = (opaque) => {
                if (typeof opaque !== "object") {
                    throw `Message argument for ${key} is not an object`;
                }
                const messageType = def.in;
                const error = messageType.verify(opaque);
                if (error !== null) {
                    console.log();
                    throw `Message argument for ${key} is malformed: ${error}`;
                }
                const message = messageType.create(opaque);
                console.log(`Sending ${key} with message ${JSON.stringify(message.toJSON())}`);
                sender(message);
            };
        }
    }
    static create(definition, sender) {
        return new Service(definition, sender);
    }
}
exports.Service = Service;
